import znc
from znc_core import CZNC
import sys
import traceback
import time
from ciscosparkapi import CiscoSparkAPI, Webhook
import web

class spark(znc.Module):
    description = "Spark module"
    module_types = [znc.CModInfo.GlobalModule]

    def OnLoad(self, args, message):
        self.api = CiscoSparkAPI(access_token="SOMETHING SOMETHING TOKEN")
        #try:
        user = znc.CZNC.Get().FindUser("sinze")
        self.network = user.FindNetwork("spark")
        self.network.PutUser(":Test!@backend PRIVMSG #Test: {} exists".format(str(user)))
        #except Exception as e:
        #    traceback.print_exc()
        #    self.GetNetwork().PutUser(":Error!@backend PRIVMSG #test :Didn't work, {e}".format(e=str(e)))
        self.me = self.api.people.me()
        self.channels = {}
        self.people = {}
        # Once its made, its made for life, TODO: Check if it exists
       # self.webhook = self.api.webhooks.create("IRC<-->Spark", "http://prime.361zn.is:7331/mods/global/spark/webhook", "messages", "created")
        #self.thread = threading.Thread(target=self.run)
        #self.thread.start()
        #self.timer = self.CreateTimer(sparkTimer, interval=1, description="Inbound communications")
        for room in self.api.rooms.list():
            name = room.title.replace(" ", "_")
            self.channels[name] = {"id" : room.id}
            if room.type == "group":
                self.network.PutUser(":SinZ!znc.in JOIN #{0}".format(name))
                for member in self.api.memberships.list(roomId=room.id):
                    self.network.PutUser(":irc.znc.in 353 SinZ + #{roomName} :+{name}".format(roomName=name, name=member.personDisplayName.replace(" ", "_")))
                self.network.PutUser(":irc.znc.in 366 SinZ #{0} :End of /NAMES list".format(name)) 
        self.network.PutUser(":SinZ!@znc.in JOIN #TEST") 
        self.network.PutUser(":Renol!renol@fake.user PRIVMSG #test :Hello World!")
        return True
    def WebRequiresLogin(self):
        return False
    def WebRequiresAdmin(self):
        return False
    def GetWebMenuTitle(self):
        return "Spark"
    def OnWebPreRequest(self, sock, page):
        try:
            self.network.PutUser(":Web!@backend PRIVMSG #test :Someone tried to access {page}".format(page=str(page)))
            self.network.PutUser(":Web!@backend PRIVMSG #test :{0}".format(sock.GetRawParam("data", False)))
            msg = self.api.messages.get(sock.GetRawParam("data", False))
            if msg.personId != self.me.id:
                person = self.api.people.get(msg.personId)
                self.network.PutUser(":Web!@backend PRIVMSG #test :" + str(person.id))
                target = "SinZ"
                type = ""
                if msg.roomType == "group":
                    type="#"
                    room = self.api.rooms.get(msg.roomId)
                    target = room.title.replace(" ", "_")
                self.network.PutUser(":{name}!{person.emails[0]} PRIVMSG {type}{target} :{msg.text}".format(type=type, target=target, name=person.displayName.replace(" ", "_"), person=person, msg=msg))
                self.network.PutUser(":Web!@backend PRIVMSG #test :Success: '{0}'".format(str(msg).replace("\r", "").replace("\n", "")))
        except Exception as e:
            self.network.PutUser(":Error!@backend PRIVMSG #test :" + str(e))
        return True
    def ValidateWebRequestCSRFCheck(self, sock, page):
        self.network.PutUser(":Web!@backend PRIVMSG #test :I was asked to verify {0}".format(page))
        return True
    
    def OnUserMsg(self, target, message):
        if str(self.GetNetwork()) != "spark":
            return znc.CONTINUE
        chanPrefix = ""
        target = str(target)
        if target[0] == "#":
            chanPrefix = "#"
            target = target[1:]
        if str(target) in self.channels.keys():
            msg = self.api.messages.create(roomId=self.channels[target]["id"], text=str(message))
        
        self.network.PutUser(":Renol!renol@fake.user PRIVMSG #TEST :{chan}, {test}, {chanPrefix}{target}|{message}".format(test=str(self.GetNetwork()),chanPrefix=chanPrefix,chan=str(self.channels),target=target,message=message))
        return znc.HALT
